#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include "FT5436.h"

uint8_t FT5436_Buf[62];

//extern int fd;

FT5436_Dev FT5436_Dev_Now,FT5436_Dev_Last;

uint16_t Touch_Point0[2];

uint16_t Touch_Point0_Index = 0;


int FT5436_Init()
{
	bcm2835_gpio_fsel(FT5436_IRQ_PIN, BCM2835_GPIO_FSEL_INPT);
	bcm2835_gpio_set_pud(FT5436_IRQ_PIN, BCM2835_GPIO_PUD_UP);
	
	bcm2835_gpio_fsel(FT5436_RESET_PIN, BCM2835_GPIO_FSEL_OUTP);

	//reset the FT5436 device
	bcm2835_gpio_write(FT5436_RESET_PIN, HIGH);
	bcm2835_delay(200);
	bcm2835_gpio_write(FT5436_RESET_PIN, LOW);
	bcm2835_delay(200);
	bcm2835_gpio_write(FT5436_RESET_PIN, HIGH);
	
		
	//write Mode_Switch to WORKING Mode
	uint8_t Mode_Switch_CMD = 0x00;
	user_i2c_write(1, Mode_Switch, &Mode_Switch_CMD, 1);
	
	return 0;	
}

int FT5436_Read_To_FIFO(int fd)
{
	user_i2c_read(1, Mode_Switch, FT5436_Buf, 62);

	//FT5436_Dev_Now.Mode_Switch_Value = (FT5436_Buf[0]&0x70)>>4;
	//printf("FT5436_Dev_Now.Mode_Switch_Value:0x%03x\r\n",FT5436_Dev_Now.Mode_Switch_Value);

	//FT5436_Dev_Now.Guesture_Value = FT5436_Buf[1];
	//printf("FT5436_Dev_Now.Guesture_Value:0x%02x\r\n",FT5436_Dev_Now.Guesture_Value);

	FT5436_Dev_Now.Cur_Point_Value = FT5436_Buf[2];
	//printf("FT5436_Dev_Now.Cur_Point_Value:%d\r\n",FT5436_Dev_Now.Cur_Point_Value);

	for(int i=0; i<FT5436_Dev_Now.Cur_Point_Value; i++){

		//FT5436_Dev_Now.point[i].Event_Flag = (FT5436_Buf[3 + 6 * i +0]&0xC0)>>6;
		//printf("FT5436_Dev_Now.point[%d].Event_Flag:0x%02x\r\n",i,FT5436_Dev_Now.point[i].Event_Flag);

		FT5436_Dev_Now.point[i].X_Position = (((uint16_t)(FT5436_Buf[3 + 6 * i +0]&0x0F))<<8) | ((uint16_t)FT5436_Buf[3 + 6 * i +1]);
		//printf("FT5436_Dev_Now.point[%d].X_Position:%d\r\n",i,FT5436_Dev_Now.point[i].X_Position);

		//FT5436_Dev_Now.point[i].Touch_ID = (FT5436_Buf[3 + 6 * i +2]&0xF0)>>4;
		//printf("FT5436_Dev_Now.point[%d].Touch_ID:%d\r\n",i,FT5436_Dev_Now.point[i].Touch_ID);

		FT5436_Dev_Now.point[i].Y_Position = (((uint16_t)(FT5436_Buf[3 + 6 * i +2]&0x0F))<<8) | ((uint16_t)FT5436_Buf[3 + 6 * i +3]);
		//printf("FT5436_Dev_Now.point[%d].Y_Position:%d\r\n",i,FT5436_Dev_Now.point[i].Y_Position);

		//FT5436_Dev_Now.point[i].Touch_Weight = FT5436_Buf[3 + 6 * i +4];
		//printf("FT5436_Dev_Now.point[%d].Touch_Weight:%d\r\n",i,FT5436_Dev_Now.point[i].Touch_Weight);

		//FT5436_Dev_Now.point[i].Touch_Area = (FT5436_Buf[3 + 6 * i +5]&0xF0)>>4;
		//printf("FT5436_Dev_Now.point[%d].Touch_Area:%d\r\n",i,FT5436_Dev_Now.point[i].Touch_Area);
		
	}

	if( FT5436_Dev_Now.point[0].X_Position !=  FT5436_Dev_Last.point[0].X_Position || \
		FT5436_Dev_Now.point[0].Y_Position !=  FT5436_Dev_Last.point[0].Y_Position){

			Touch_Point0[0] = FT5436_Dev_Now.point[0].X_Position;
			printf("Touch_X:%d\r\n",Touch_Point0[0]);

			Touch_Point0[1] = FT5436_Dev_Now.point[0].Y_Position;
			printf("Touch_Y:%d\r\n",Touch_Point0[1]);

			Touch_Point0_Index ++ ;
			Touch_Point0_Index %= 1800;
			printf("Point %d\r\n",Touch_Point0_Index);

			write(fd,Touch_Point0,sizeof(Touch_Point0));
	}

	FT5436_Dev_Last = FT5436_Dev_Now;

	return 0;
}
