#ifndef __FT5436_H__
#define __FT5436_H__

#include "DEV_Config.h"

#define Mode_Switch     0x00
#define Guesture        0x01
#define Cur_Point       0x02

#define TOUCH1_XH       0x03
#define TOUCH1_XL       0x04
#define TOUCH1_YH       0x05
#define TOUCH1_YL       0x06
#define TOUCH1_WEIGHT   0x07
#define TOUCH1_MISC     0x08

#define TOUCH2_XH       0x09
#define TOUCH2_XL       0x0A
#define TOUCH2_YH       0x0B
#define TOUCH2_YL       0x0C
#define TOUCH2_WEIGHT   0x0D
#define TOUCH2_MISC     0x0E

#define TOUCH3_XH       0x0F
#define TOUCH3_XL       0x10
#define TOUCH3_YH       0x11
#define TOUCH3_YL       0x12
#define TOUCH3_WEIGHT   0x13
#define TOUCH3_MISC     0x14

#define TOUCH4_XH       0x15
#define TOUCH4_XL       0x16
#define TOUCH4_YH       0x17
#define TOUCH4_YL       0x18
#define TOUCH4_WEIGHT   0x19
#define TOUCH4_MISC     0x1A

#define TOUCH5_XH       0x1B
#define TOUCH5_XL       0x1C
#define TOUCH5_YH       0x1D
#define TOUCH5_YL       0x1E
#define TOUCH5_WEIGHT   0x1F
#define TOUCH5_MISC     0x20

#define TOUCH6_XH       0x21
#define TOUCH6_XL       0x22
#define TOUCH6_YH       0x23
#define TOUCH6_YL       0x24
#define TOUCH6_WEIGHT   0x25
#define TOUCH6_MISC     0x26

#define TOUCH7_XH       0x27
#define TOUCH7_XL       0x28
#define TOUCH7_YH       0x29
#define TOUCH7_YL       0x2A
#define TOUCH7_WEIGHT   0x2B
#define TOUCH7_MISC     0x2C

#define TOUCH8_XH       0x2D
#define TOUCH8_XL       0x2E
#define TOUCH8_YH       0x2F
#define TOUCH8_YL       0x30
#define TOUCH8_WEIGHT   0x31
#define TOUCH8_MISC     0x32

#define TOUCH9_XH       0x33
#define TOUCH9_XL       0x34
#define TOUCH9_YH       0x35
#define TOUCH9_YL       0x36
#define TOUCH9_WEIGHT   0x37
#define TOUCH9_MISC     0x38

#define TOUCH10_XH      0x39
#define TOUCH10_XL      0x3A
#define TOUCH10_YH      0x3B
#define TOUCH10_YL      0x3C
#define TOUCH10_WEIGHT  0x3D
#define TOUCH10_MISC    0x3E

#define FT5436_RESET_PIN  22
#define FT5436_IRQ_PIN    23

#define FT5436_Addr     0x38

typedef struct
{
	uint8_t Event_Flag;
	uint16_t X_Position;
	uint8_t Touch_ID;
	uint16_t Y_Position;
	uint8_t Touch_Weight;
	uint8_t Touch_Area;
}FT5436_Point;


typedef struct
{
	uint8_t Mode_Switch_Value;

	uint8_t Guesture_Value;

	uint8_t Cur_Point_Value;
	
	FT5436_Point point[10];
	
}FT5436_Dev;


extern uint8_t FT5436_Buf[62];

extern FT5436_Dev FT5436_Dev_Now,FT5436_Dev_Last;


extern uint16_t Touch_Point0[2];

extern uint16_t Touch_Point0_Index;


int FT5436_Init();

int FT5436_Read_To_FIFO(int fd);

#endif